import { defineComponent as _, resolveComponent as x, openBlock as g, createBlock as v, unref as h } from "vue";
import { message as d } from "ant-design-vue";
import { e as k, u as m } from "./Workspace-b0c76eb5.mjs";
import { cloneDeep as u } from "lodash";
import { _ as F } from "./_commonjsHelpers-4c55c438.mjs";
const C = [
  {
    operator: "like",
    renderer: {
      type: "TextField",
      options: {
        field: "username",
        label: "用户名"
      }
    }
  },
  {
    operator: "like",
    renderer: {
      type: "TextField",
      options: {
        field: "nickname",
        label: "姓名"
      }
    }
  },
  {
    operator: "like",
    renderer: {
      type: "TextField",
      options: {
        field: "phone",
        label: "手机"
      }
    }
  }
], Z = [
  {
    key: "_edit",
    label: "编辑"
    // color: '#f00',
    // expression: 'state=='1''
  },
  {
    key: "_reset",
    label: "重置",
    confirm: !0
  },
  {
    key: "_delete",
    label: "删除",
    color: "#f00",
    confirm: !0,
    showRoles: ["admin"]
  },
  {
    key: "_stop",
    label: "停用",
    color: "#f00",
    confirm: !0,
    expression: (t) => t.enabled
  },
  {
    key: "_start",
    label: "启用",
    color: "green",
    confirm: !0,
    expression: (t) => !t.enabled
  }
], G = [
  { key: "_add", label: "添加", icon: "UserAddOutlined" }
], I = [
  {
    name: "username",
    label: "用户名",
    align: "center"
  },
  {
    name: "nickname",
    label: "姓名",
    align: "center"
  },
  {
    name: "phone",
    label: "手机号",
    align: "center"
  },
  {
    name: "role_name",
    type: "json",
    label: "角色",
    align: "center"
  },
  {
    name: "enabled",
    align: "center",
    label: "状态",
    dict: "状态"
  }
], P = [
  {
    name: "yn",
    type: "inline",
    items: [
      {
        label: "是",
        value: !0
      },
      {
        label: "否",
        value: !1
      }
    ]
  },
  {
    name: "状态",
    type: "inline",
    items: [
      {
        label: "已停用",
        value: !1,
        tagColor: "error",
        tag: !0
      },
      {
        label: "运行中",
        value: !0,
        tagColor: "success",
        tag: !0
      }
    ]
  }
], T = [
  {
    name: "hideshow",
    type: "inline",
    items: [
      {
        label: "显示",
        value: 1
      },
      {
        label: "隐藏",
        value: 0
      }
    ]
  },
  {
    name: "yn",
    type: "inline",
    items: [
      {
        label: "是",
        value: 1
      },
      {
        label: "否",
        value: 0
      }
    ]
  },
  {
    name: "componenturi",
    type: "inline"
  }
], w = {
  hide: "hideshow",
  secondmenu: "yn"
}, q = {}, D = [
  {
    type: "TextField",
    options: {
      type: "text",
      field: "username",
      label: "用户名",
      required: !0
    }
  },
  {
    type: "TextField",
    options: {
      type: "text",
      field: "password",
      label: "密码",
      mode: "password",
      required: !0
    }
  }
], R = [
  {
    type: "TextField",
    options: {
      type: "text",
      field: "nickname",
      label: "姓名",
      required: !0
    }
  },
  {
    type: "SelectField",
    options: {
      type: "json",
      mode: "multiple",
      field: "roles",
      dictRef: "role",
      required: !0,
      label: "角色"
    }
  },
  {
    type: "TextField",
    options: {
      type: "text",
      field: "phone",
      maxLength: 11,
      label: "手机号"
    }
  },
  {
    type: "TextField",
    options: {
      type: "text",
      field: "email",
      label: "邮箱"
    }
  },
  {
    type: "TextField",
    options: {
      type: "text",
      field: "company",
      label: "单位"
    }
  },
  {
    type: "TextField",
    options: {
      type: "text",
      field: "department",
      label: "科室"
    }
  }
], z = {
  fieldValidators: [
    {
      field: "username",
      label: "用户名",
      validators: [
        {
          type: "regex",
          options: {
            pattern: /^\S+$/,
            message: "用户名不能包含空格"
          }
        },
        {
          type: "regex",
          options: {
            pattern: /^[a-zA-Z][a-zA-Z0-9]{3,15}$/,
            message: "必须由英文开头,仅可包含英文和数字,4-16位"
          }
        }
      ]
    },
    {
      field: "password",
      label: "密码",
      validators: [
        {
          type: "regex",
          options: {
            pattern: /^[a-zA-Z0-9]{6,16}$/,
            message: "仅可包含英文和数字,6-16位"
          }
        }
      ]
    },
    {
      field: "phone",
      label: "手机号",
      validators: [
        {
          type: "regex",
          options: {
            pattern: /^1(3[0-9]|4[5,7]|5[0,1,2,3,5,6,7,8,9]|6[2,5,6,7]|7[0,1,2,3,5,6,7,8]|8[0-9]|9[1,5,8,9])\d{8}$/,
            message: "请输入正确的手机号"
          }
        }
      ]
    },
    {
      field: "email",
      label: "邮箱",
      validators: [
        {
          type: "regex",
          options: {
            pattern: /^[a-z0-9]+([._\\-]*[a-z0-9])*@([a-z0-9]+[-a-z0-9]*[a-z0-9]+.){1,63}[a-z0-9]+$/,
            message: "请输入正确的邮箱"
          }
        }
      ]
    }
  ]
}, O = {
  layout: q,
  formDicts: T,
  dictRefs: w,
  validators: z
}, V = {
  formDef: O,
  formRecordData: {}
};
async function E() {
  let t = [];
  try {
    const { list: o } = await k.queryAllRole();
    t = o.map((r) => ({ label: r.name, value: r._id }));
  } catch (o) {
    console.error(o);
  }
  return t;
}
function j(t) {
  const o = u(D), r = u(R);
  let n = [];
  switch (t) {
    case "添加":
      n = [...o, ...r];
      break;
    case "编辑":
      n = [o[0], ...r];
  }
  return n;
}
const L = /* @__PURE__ */ _({
  name: "UserManageForm",
  __name: "index",
  props: {
    formData: { type: Object, required: !0 },
    type: { type: String, required: !0 },
    options: { type: Object, required: !0 },
    roleMap: { type: Object, required: !0 }
  },
  emits: ["refreshTable"],
  setup(t, { expose: o, emit: r }) {
    const n = t, f = r, { formData: i, type: s, options: l, roleMap: p } = n;
    if (watch(
      () => s,
      (a) => {
        l.formDef.layout = j(a);
      },
      {
        immediate: !0
      }
    ), l.formRecordData = {}, s == "添加")
      l.formRecordData = {};
    else {
      l.formRecordData = i;
      let a = i.role_name.map((e) => p[e] ? p[e].value : "");
      l.formRecordData.roles = a.filter((e) => e !== "");
    }
    const c = ref();
    async function y() {
      try {
        const { state: a, data: e } = await c.value.submit();
        a && (s === "添加" ? (await m.addUser(e), d.success("添加成功！")) : (e._id = e.user_id, delete e.role_code, delete e.role_name, await m.updateUser(e), d.success("修改成功！")), f("refreshTable"));
      } catch ({ msg: a }) {
        console.log(a);
      }
    }
    return o({ onSubmit: y }), (a, e) => {
      const b = x("GTForm");
      return g(), v(b, {
        options: h(l),
        ref_key: "formBox",
        ref: c
      }, null, 8, ["options"]);
    };
  }
}), S = /* @__PURE__ */ F(L, [["__file", "/Users/qiweicun/Desktop/vscode/mis-component-vue3/src/views/UserManage/components/Form/index.vue"]]), H = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: S
}, Symbol.toStringTag, { value: "Module" }));
export {
  S as F,
  H as _,
  I as a,
  T as b,
  P as d,
  V as f,
  E as g,
  Z as r,
  C as s,
  G as t
};
