import { defineComponent as G, resolveComponent as b, openBlock as p, createElementBlock as O, createVNode as y, unref as t, isRef as V, withCtx as F, createElementVNode as B, Fragment as E, renderList as I, createBlock as T, createTextVNode as $, toDisplayString as U, createCommentVNode as j } from "vue";
import { G as H } from "./index-b41ab7d8.mjs";
import { G as K } from "./index-0dfca83c.mjs";
import { d as i } from "./index-3b037843.mjs";
import { message as u } from "ant-design-vue";
import { _ as M } from "./_commonjsHelpers-4c55c438.mjs";
const P = [
  {
    operator: "=",
    renderer: {
      type: "TextField",
      options: {
        field: "name",
        label: "规则名称"
      }
    }
  },
  {
    operator: "=",
    renderer: {
      type: "TextField",
      options: {
        field: "rule_value",
        label: "规则值"
      }
    }
  }
], A = [
  { name: "name", label: "规则名称", align: "center" },
  { name: "rule_table", label: "规则表" },
  { name: "rule_column", label: "规则字段", align: "center" },
  { name: "rule_value", label: "规则值", align: "center" },
  {
    name: "rule_conditions",
    label: "条件规则",
    align: "center",
    width: 100
  }
], Q = [
  { label: "添加", key: "add", icon: "PlusOutlined" }
], J = [
  { label: "编辑", key: "edit" },
  { label: "删除", key: "delete", color: "#f00", confirm: !0 }
], W = {
  dicts: [
    {
      name: "规则条件",
      type: "enum",
      items: ["<=", "NOT LIKE", "LIKE", "CONTAINS", "<", "!=", "=", ">", ">="]
    }
  ],
  layout: {
    itemOptions: {
      labelSpan: 6,
      wrapperSpan: 18
    },
    children: [
      {
        type: "TextField",
        options: {
          type: "text",
          label: "规则名称",
          required: !0,
          field: "name"
        }
      },
      {
        type: "TextField",
        options: {
          type: "text",
          label: "规则表",
          required: !0,
          readonly: !0,
          field: "rule_table"
        }
      },
      {
        type: "TextField",
        options: {
          type: "text",
          label: "规则字段",
          required: !0,
          field: "rule_column"
        }
      },
      {
        type: "SelectField",
        options: {
          type: "text",
          label: "规则条件",
          required: !0,
          field: "rule_conditions",
          dictRef: "规则条件"
        }
      },
      {
        type: "TextField",
        options: {
          type: "text",
          label: "规则值",
          required: !0,
          field: "rule_value"
        }
      }
    ]
  },
  dictRefs: {
    rule_conditions: "规则条件"
  },
  validators: {
    fieldValidators: [
      {
        label: "规则名称",
        validators: [
          {
            type: "required"
          }
        ],
        field: "name"
      },
      {
        label: "规则字段",
        validators: [
          {
            type: "required"
          }
        ],
        field: "rule_column"
      },
      {
        label: "规则条件",
        validators: [
          {
            type: "required"
          }
        ],
        field: "rule_conditions"
      },
      {
        label: "规则值",
        validators: [
          {
            type: "required"
          }
        ],
        field: "rule_value"
      },
      {
        label: "规则表",
        validators: [
          {
            type: "required"
          }
        ],
        field: "rule_table"
      }
    ],
    subformValidators: []
  }
}, q = {
  提交数据: {
    name: "查看本人提交数据",
    rule_column: "create_by",
    rule_conditions: "=",
    rule_value: "${userId}"
  },
  省级数据: {
    name: "查看省级数据列表",
    rule_column: "省编码",
    rule_conditions: "=",
    rule_value: "${pcode}"
  },
  市级数据: {
    name: "查看市级数据列表",
    rule_column: "市编码",
    rule_conditions: "=",
    rule_value: "${ccode}"
  },
  县级数据: {
    name: "查看县级数据列表",
    rule_column: "县编码",
    rule_conditions: "=",
    rule_value: "${fcode}"
  }
}, X = { class: "rule-max" }, Y = { class: "button-max" }, Z = /* @__PURE__ */ G({
  name: "FormRule",
  __name: "index",
  props: {
    formName: { type: String, required: !0 }
  },
  setup(w) {
    const d = w, v = ref([]), o = ref({ page: 1, size: 10, rule_table: d.formName }), g = ref(0), m = ref(!1), a = ref(!1), f = ref(!1), _ = ref(!0), x = ref(""), k = ref(), n = reactive({
      formDef: W,
      formRecordData: {
        rule_table: d.formName
      }
    }), c = async () => {
      m.value = !0;
      try {
        const e = await i.getRules(o.value);
        v.value = e.list, g.value = e.total;
      } catch (e) {
        u.error(e.msg);
      }
      m.value = !1;
    }, C = async () => {
      try {
        const e = await i.getSupportRelation();
        n.formDef.dicts[0].items = e;
      } catch (e) {
        console.log("error :>> ", e);
      }
    }, R = ({ key: e, data: r }) => {
      switch (x.value = e, e) {
        case "add":
          n.formRecordData = {
            rule_table: d.formName
          }, a.value = !0;
          break;
        case "edit":
          n.formRecordData = r, a.value = !0;
          break;
        case "delete":
          N(r);
          break;
      }
    }, h = (e) => {
      _.value = !1, n.formRecordData = { ...n.formRecordData, ...q[e] }, nextTick(() => {
        _.value = !0;
      });
    }, S = async () => {
      f.value = !0;
      const { data: e, state: r } = await k.value.submit();
      if (r)
        try {
          e._id ? await i.updateRule(e._id, e) : await i.addRule(e), u.success("操作成功！"), o.value.page = 1, c(), a.value = !1;
        } catch (s) {
          u.error(s.msg);
        }
      f.value = !1;
    }, N = async ({ _id: e }) => {
      try {
        await i.deleteRule(e), u.success("删除成功！"), o.value.page = 1, c();
      } catch (r) {
        u.error(r.msg);
      }
    }, D = (e) => {
      const r = {
        page: 1,
        size: 10,
        rule_table: d.formName
      };
      e.forEach((s) => {
        r[s.name] = s.value;
      }), o.value = r, c();
    };
    return onMounted(() => {
      c(), C();
    }), (e, r) => {
      const s = b("a-button"), z = b("GTForm"), L = b("a-modal");
      return p(), O("div", X, [
        y(H, {
          fields: t(P),
          onSearch: D,
          "list-width": 260
        }, null, 8, ["fields"]),
        y(K, {
          fields: t(A),
          data: t(v),
          tableOperators: t(Q),
          recordOperators: t(J),
          "page-current": t(o).page,
          "onUpdate:pageCurrent": r[0] || (r[0] = (l) => t(o).page = l),
          "page-size": t(o).size,
          "onUpdate:pageSize": r[1] || (r[1] = (l) => t(o).size = l),
          onRecordOperatorClick: R,
          onTableOperatorClick: R,
          total: t(g),
          "y-offset": 280,
          loading: t(m)
        }, null, 8, ["fields", "data", "tableOperators", "recordOperators", "page-current", "page-size", "total", "loading"]),
        y(L, {
          destroyOnClose: "",
          maskClosable: !1,
          getContainer: ".rule-max",
          class: "rule-model",
          open: t(a),
          "onUpdate:open": r[2] || (r[2] = (l) => V(a) ? a.value = l : null),
          style: { width: "600px" },
          onOk: S,
          confirmLoading: t(f),
          title: t(x) == "add" ? "新增规则" : "编辑规则"
        }, {
          default: F(() => [
            B("div", Y, [
              (p(!0), O(E, null, I(Object.keys(t(q)), (l) => (p(), T(s, {
                type: "primary",
                key: l,
                onClick: (te) => h(l)
              }, {
                default: F(() => [
                  $(U(l), 1)
                ]),
                _: 2
              }, 1032, ["onClick"]))), 128))
            ]),
            t(_) ? (p(), T(z, {
              key: 0,
              ref_key: "formBox",
              ref: k,
              options: t(n)
            }, null, 8, ["options"])) : j("", !0)
          ]),
          _: 1
        }, 8, ["open", "confirmLoading", "title"])
      ]);
    };
  }
});
const ee = /* @__PURE__ */ M(Z, [["__scopeId", "data-v-fb379215"], ["__file", "/Users/qiweicun/Desktop/vscode/mis-component-vue3/src/views/FormDesign/components/FormRule/index.vue"]]), ie = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: ee
}, Symbol.toStringTag, { value: "Module" }));
export {
  ee as F,
  ie as _
};
